m4-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

FYI: 85-gary-synch-commit-scripts.patch


From: Gary V. Vaughan
Subject: FYI: 85-gary-synch-commit-scripts.patch
Date: Sun, 29 Feb 2004 17:57:20 +0000 (GMT)
User-agent: mailnotify/0.2

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Applied to HEAD.
- -- 
Gary V. Vaughan      ())_.  address@hidden,gnu.org}
Research Scientist   ( '/   http://www.oranda.demon.co.uk
GNU Hacker           / )=   http://www.gnu.org/software/libtool
Technical Author   `(_~)_   http://sources.redhat.com/autobook
__________________________________________________________
This patch notification generated by cvsapply version 0.13
http://savannah.gnu.org/projects/cvs-utils
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.2 (Darwin)

iD8DBQFAQif/FRMICSmD1gYRAtQoAKCuDDfEEQYZVU/EtA8OgyV60hwyWACaA7N3
/XMtOGVrcPwsOc/ZPVeG+5Y=
=wTMx
-----END PGP SIGNATURE-----
Index: ChangeLog
from  Gary V. Vaughan  <address@hidden>

        * config/mailnotify: New file for mailing commit notifications,
        imported from cvs-utils.
        * commit: Updated from cvs-utils and tweaked for m4.

Index: commit
===================================================================
RCS file: /cvsroot/m4/m4/commit,v
retrieving revision 1.2
diff -u -p -u -r1.2 commit
--- commit 30 May 2003 15:13:31 -0000 1.2
+++ commit 29 Feb 2004 16:51:49 -0000
@@ -1,17 +1,51 @@
 #! /bin/sh
 
-# clcommit version 0.9.5
+# clcommit (GNU cvs-utils) version 0.11
+# Written by Gary V. Vaughan <address@hidden>
+# and Alexandre Oliva <address@hidden>
+
+# Copyright (C) 1999, 2000, 2004 Free Software Foundation, Inc.
+# This is free software; see the source for copying conditions.  There is NO
+# warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, a copy can be downloaded from
+# http://www.gnu.org/copyleft/gpl.html, or by writing to the Free
+# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
+# MA 02111-1307, USA.
+
+# Usage: $progname [-v] [-h] [-f] [-l] [-n] [-q] [-z N] [-C ChangeLog_file]
+#          [-m msg|-F msg_file|-1] [-s addr [--from addr]] [--] [file|dir ...]
+
+# -C file --changelog=file   extract commit message from specified ChangeLog
+# -zN     --compress=N       set compression level (0-9, 0=none, 9=max)
+# -n      --dry-run          don't commit anything
+#         --fast             same as --force --first
+# -F file --file=file        read commit message from file
+# -1      --first            extract first entry from ChangeLog, no cvs diff
+# -f      --force            don't check (unless *followed* by -n), and just
+#                            display commit message instead of running $PAGER
+#         --from=addr        override default from address in commit email
+# -l      --local            don't descend into subdirectories
+# -m msg  --message=msg      set commit message
+#         --msg=msg          same as -m
+# -q      --quiet            run cvs in quiet mode
+# -s addr --sendmail=addr    send a commit email of the differences to ADDR
+#         --signature[=file] add FILE to the end of the email (~/.signature)
+# -v      --version          print version information
+# -h,-?   --help             print short or long help message
 
-# Copyright (C) 1999, 2000, Free Software Foundation
-
-# This script is Free Software, and it can be copied, distributed and
-# modified as defined in the GNU General Public License.  A copy of
-# its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
-
-# Originally by Gary V. Vaughan <address@hidden>
-# Pretty much rewritten by Alexandre Oliva <address@hidden>
-
-# This scripts eases checking in changes to CVS-maintained projects
+# This script eases checking in changes to CVS-maintained projects
 # with ChangeLog files.  It will check that there have been no
 # conflicting commits in the CVS repository and print which files it
 # is going to commit to stderr.  A list of files to compare and to
@@ -30,267 +64,405 @@
 # are checked in, unless `-n' was specified, in which case nothing is
 # checked in.
 
-# usage: clcommit [-v] [-h] [-f] [-l] [-n] [-q] [-z N] [-C ChangeLog_file]
-#                 [-m msg|-F msg_file|-1] [--] [file|dir ...]
+# Report bugs to <address@hidden>
 
-# -f      --force       don't check (unless *followed* by -n), and just 
-#                       display commit message instead of running $PAGER
-# -l      --local       don't descend into subdirectories
-# -m msg  --message=msg set commit message
-#         --msg=msg     same as -m
-# -F file --file=file   read commit message from file
-# -1      --first       extract first entry from ChangeLog, no cvs diff
-# -C file --changelog=file extract commit message from specified ChangeLog
-#         --fast        same as --force --first
-# -n      --dry-run     don't commit anything
-# -q      --quiet       run cvs in quiet mode
-# -zN     --compress=N  set compression level (0-9, 0=none, 9=max)
-# -v      --version     print version information
-# -h,-?   --help        print short or long help message
-
-name=clcommit
-: ${CVS=cvs}
-cvsopt=
-updateopt=
-commitopt=
-dry_run=false
-commit=:
-update=:
+: ${CVS="cvs"}
+: ${MAILNOTIFY="./config/mailnotify"}
+: ${MKSTAMP="./config/mkstamp"}
+: ${MV="mv -f"}
+: ${RM="rm -f"}
+: ${SED="sed"}
+
+SHELL="/bin/sh"
+dirname="s,/[^/]*$,,"
+basename="s,^.*/,,g"
+
+# Work around backward compatibility issue on IRIX 6.5. On IRIX 6.4+, sh
+# is ksh but when the shell is invoked as "sh" and the current value of
+# the _XPG environment variable is not equal to 1 (one), the special
+# positional parameter $0, within a function call, is the name of the
+# function.
+progpath="$0"
+
+# The name of this program:
+progname=`echo "$progpath" | $SED "$basename"`
+PROGRAM=clcommit
+
+# Global variables:
+EXIT_SUCCESS=0
+EXIT_FAILURE=1
+
+cvs_flags=
+update_flags=
+commit_flags=
+opt_commit=:
+opt_update=:
+opt_first=false
+
+sendmail_to="M4 Commit <address@hidden>"
+sendmail_from=
+exit_cmd=:
+
+# Locations for important files
+signature_file=
 log_file="${TMPDIR-/tmp}/commitlog.$$"
-first=false
 
-rm -f "$log_file"
-trap 'rm -f "$log_file"; exit 1' 1 2 15
+$RM "${log_file}*"
+trap '$RM "${log_file}*"; exit $EXIT_FAILURE' 1 2 15
 
-# this just eases exit handling
-main_repeat=":"
-while $main_repeat; do
-
-repeat="test $# -gt 0"
-while $repeat; do
-    case "$1" in
-    --fast)
-        shift
-       set fnord --force --first ${1+"$@"}
-       shift
-       ;;
-    -f|--force)
-       update=false
-       PAGER=cat
-       shift
-       ;;
-    -l|--local)
-       updateopt="$updateopt -l"
-       commitopt="$commitopt -l"
-       shift
-       ;;
-    -m|--message|--msg)
-       if test $# = 1; then
-           echo "$name: missing argument for $1" >&2
-           break
-       fi
-       if $first || test -f "$log_file"; then
-           echo "$name: you can have at most one of -m, -F and -1" >&2
-           break
-       fi
-       shift
-       echo "$1" > "$log_file"
-       shift
-       ;;
-    -F|--file)
-       if $first || test -f "$log_file"; then
-           echo "$name: you can have at most one of -m, -F and -1" >&2
-           break
-       fi
-       if test $# = 1; then
-           echo "$name: missing argument for $1" >&2
-           break
-       fi
-       shift
-       if cat < "$1" > "$log_file"; then :; else
-           break
-       fi
-       shift
-       ;;
-    -1|--first)
-        if test -f "$log_File"; then
-           echo "$name: you can have at most one of -m, -F and -1" >&2
-           break
-       fi
-       first=:
-       shift
-       ;;
-    -C|--[cC]hange[lL]og)
-        if test $# = 1; then
-           echo "$name: missing argument for $1" >&2
-           break
-       fi
-       shift
-       if test ! -f "$1"; then
-           echo "$name: ChangeLog file \`$1' does not exist" >&2
-           break
-       fi
-       ChangeLog="$1"
-       shift
-       ;;
-    -n|--dry-run)
-       commit=false
-       update=true
-       shift
-       ;;
-    -q|--quiet)
-       cvsopt="$cvsopt -q"
-       shift
-       ;;
-    -z|--compress)
-       if test $# = 1; then
-           echo "$name: missing argument for $1" >&2
-           break
-       fi
-       case "$2" in
-       [0-9]) :;;
-       *)  echo "$name: invalid argument for $1" >&2
-           break
-           ;;
-       esac
-       cvsopt="$cvsopt -z$2"
-       shift
-       shift
-       ;;
+set -e
 
-    -m*|-F*|-C*|-z*)
-       opt=`echo "$1" | sed '1s/^\(..\).*$/\1/;q'`
-       arg=`echo "$1" | sed '1s/^-[a-zA-Z0-9]//'`
-       shift
-       set -- "$opt" "$arg" ${1+"$@"}
-       ;;
-    --message=*|--msg=*|--file=*|--[Cc]hange[Ll]og=*|--compress=*)
-       opt=`echo "$1" | sed '1s/^\(--[^=]*\)=.*/\1/;q'`
-       arg=`echo "$1" | sed '1s/^--[^=]*=//'`
-       shift
-       set -- "$opt" "$arg" ${1+"$@"}
-       ;;
 
-    -v|--version)
-       sed '/^# '$name' version /,/^# Heavily modified by/ { s/^# //; p; }; d' 
< $0
-       exit 0
-       ;;
-    -\?|-h)
-       sed '/^# usage:/,/# -h/ { s/^# //; p; }; d' < $0 &&
-       echo
-       echo "run \`$name --help | more' for full usage"
-       exit 0
-       ;;
-    --help)
-       sed '/^# '$name' version /,/^[^#]/ { /^[^#]/ d; s/^# //; p; }; d' < $0
-       exit 0
-       ;;
-    --)
-       shift
-       repeat=false
-       ;;
-    -*)
-       echo "$name: invalid flag $1" >&2
-       break
-       ;;
-    *)
-       repeat=false
-       ;;
+# func_echo arg...
+# Echo program name prefixed message.
+func_echo ()
+{
+    echo $progname: ${1+"$@"}
+}
+
+# func_error arg...
+# Echo program name prefixed message to standard error.
+func_error ()
+{
+    echo $progname: ${1+"$@"} 1>&2
+}
+
+# func_fatal_error arg...
+# Echo program name prefixed message to standard error, and exit.
+func_fatal_error ()
+{
+    func_error ${1+"$@"}
+    exit $EXIT_FAILURE
+}
+
+# func_verbose arg...
+# Echo program name prefixed message in verbose mode only.
+func_verbose ()
+{
+    $opt_verbose && func_error ${1+"$@"}
+}
+
+# func_fatal_help arg...
+# Echo program name prefixed message to standard error, followed by
+# a help hint, and exit.
+func_fatal_help ()
+{
+    func_error ${1+"$@"}
+    func_fatal_error "Try \`$progname --help' for more information."
+}
+
+# func_missing_arg argname
+# Echo program name prefixed message to standard error and set global
+# exit_cmd.
+func_missing_arg ()
+{
+   func_error "missing argument for $1"
+   exit_cmd=exit
+}
+
+# func_usage
+# Echo short help message to standard output and exit.
+func_usage ()
+{
+    $SED '/^# Usage:/,/# -h/ {
+        s/^# //; s/^# *$//;
+       s/\$progname/'$progname'/;
+       p;
+    }; d' < "$progpath"
+    echo
+    echo "run \`$progname --help | more' for full usage"
+    exit $EXIT_SUCCESS
+}
+
+# func_help
+# Echo long help message to standard output and exit.
+func_help ()
+{
+    $SED '/^# Usage:/,/# Report bugs to/ {
+        s/^# //; s/^# *$//;
+       s/\$progname/'$progname'/;
+       p;
+     }; d' < "$progpath"
+    exit $EXIT_SUCCESS
+}
+
+# func_version
+# Echo version message to standard output and exit.
+func_version ()
+{
+    $SED '/^# '$PROGRAM' (GNU /,/# warranty; / {
+        s/^# //; s/^# *$//;
+        s/\((C)\)[ 0-9,-]*\( [1-9][0-9]*\)/\1\2/;
+        p;
+     }; d' < "$progpath"
+     exit $EXIT_SUCCESS
+}
+
+# Parse options once, thoroughly.  This comes as soon as possible in
+# the script to make things like `commit --version' happen quickly.
+{
+  # sed scripts:
+  my_sed_single_opt='1s/^\(..\).*$/\1/;q'
+  my_sed_single_rest='1s/^..\(.*\)$/\1/;q'
+  my_sed_long_opt='1s/^\(--[^=]*\)=.*/\1/;q'
+  my_sed_long_arg='1s/^--[^=]*=//'
+
+  # this just eases exit handling
+  while test $# -gt 0; do
+    opt="$1"
+    shift
+    case $opt in
+
+      --fast)          set -- --force --first ${1+"$@"}        ;;
+
+      -f|--force)      opt_update=false; PAGER=cat             ;;
+
+      --from)          test $# = 0 && func_missing_arg $opt && break
+                       sendmail_from="$1"
+                       shift
+                       ;;
+
+      -l|--local)      update_flags="$update_flags -l"
+                       commit_flags="$commit_flags -l"
+                       ;;
+
+      -m|--message|--msg)
+                       test $# = 0 && func_missing_arg $opt && break
+                       if $opt_first || test -f "$log_file"; then
+                         func_error "you can have at most one of -m, -F and -1"
+                         break
+                       fi
+                       echo "$1" > "$log_file"
+                       shift
+                       ;;
+
+      -F|--file)       test $# = 0 && func_missing_arg $opt && break
+                       if $opt_first || test -f "$log_file"; then
+                         func_error "you can have at most one of -m, -F and -1"
+                         break
+                       fi
+                       if cat < "$1" > "$log_file"; then :; else
+                         break
+                       fi
+                       shift
+                       ;;
+
+      -1|--first)       if test -f "$log_File"; then
+                         func_error "you can have at most one of -m, -F and -1"
+                         break
+                       fi
+                       opt_first=:
+                       ;;
+
+      -C|--[cC]hange[lL]og)
+                       test $# = 0 && func_missing_arg $opt && break
+                       if test -f "$1"; then :; else
+                         func_error "ChangeLog file \`$1' does not exist"
+                         break
+                       fi
+                       ChangeLog="$1"
+                       shift
+                       ;;
+
+      -n|--dry-run)    opt_commit=false; opt_update=:          ;;
+
+      -q|--quiet)      cvs_flags="$cvs_flags -q"               ;;
+
+      -s|--sendmail)   test $# = 0 && func_missing_arg $opt && break
+                       sendmail_to="$1"
+                       shift
+                       ;;
+
+    --signature)       test $# = 0 && func_missing_arg $opt && break
+                       signature_file="$HOME/.signature"
+                       case $1 in
+                         -*) ;;
+                         *)  signature_file="$1"; shift ;;
+                       esac
+                       if test -f "$signature_file"; then :; else
+                         func_error "\`$signature_file': file not found"
+                         break
+                       fi
+                       ;;
+
+      -z|--compress)
+                       test $# = 0 && func_missing_arg $opt && break
+                       case "$1" in
+                         [0-9]) :;;
+                         *)  func_error "invalid argument for $opt"
+                             break
+                             ;;
+                       esac
+                       cvs_flags="$cvs_flags -z$1"
+                       shift
+                       ;;
+
+      # Separate optargs to long options:
+      
--message=*|--msg=*|--from=*|--file=*|--[Cc]hange[Ll]og=*|--compress=*|--sendmail=*|--signature=*)
+                       arg=`echo "$opt" | $SED "$my_sed_long_arg"`
+                       opt=`echo "$opt" | $SED "$my_sed_long_opt"`
+                       set -- "$opt" "$arg" ${1+"$@"}
+                       ;;
+
+      # Separate optargs to short options:
+      -m*|-F*|-C*|-s*|-z*)
+                       arg=`echo "$opt" |$SED "$my_sed_single_rest"`
+                       opt=`echo "$opt" |$SED "$my_sed_single_opt"`
+                       set -- "$opt" "$arg" ${1+"$@"}
+                       ;;
+
+      # Separate non-argument short options:
+      -f*|-1*|-n*|-q*)
+                       rest=`echo "$opt" |$SED "$my_sed_single_rest"`
+                       opt=`echo "$opt" |$SED "$my_sed_single_opt"`
+                       set -- "$opt" "-$rest" ${1+"$@"}
+                       ;;
+
+      -\?|-h)          func_usage                                      ;;
+      --help)          func_help                                       ;;
+      --version)       func_version                                    ;;
+      --)              break                                           ;;
+      -*)              func_fatal_help "unrecognized option \`$opt'"   ;;
+      *)               set -- "$opt" ${1+"$@"};        break           ;;
     esac
-done
-# might have used break 2 within the previous loop, but so what
-$repeat && break
-
-$update && \
-if echo "$name: checking for conflicts..." >&2
-   ($CVS $cvsopt -q -n update $updateopt ${1+"$@"} \
-    | while read line; do
-       echo "$line"
-       echo "$line" >&3
-      done | grep '^C') 3>&1 >/dev/null; then
-  echo "$name: some conflicts were found, aborting..." >&2
-  break
-fi
+  done
+
+  if test -z "$sendmail_to"; then
+
+    # can't have a from address without a destination address
+    test -n "$sendmail_from" &&
+      func_error "can't use --from without --sendmail." && exit_cmd=exit
+
+    # can't use a signature file without a destination address
+    test -n "$signature_file" &&
+      func_error "can't use --signature without --sendmail." && exit_cmd=exit
+  fi
+
+  # Bail if the options were screwed
+  $exit_cmd $EXIT_FAILURE
+}
+
+
+$opt_update && {
+   func_error "$progname: checking for conflicts..."
+   if ( $CVS $cvs_flags -q -n update $update_flags ${1+"$@"} |
+          while read line; do
+           echo "$line"
+           echo "$line" >&3
+          done | grep '^C'
+      ) 3>&1 >/dev/null; then
+    func_fatal_error "some conflicts were found, aborting..."
+  fi
+}
 
-if test ! -f "$log_file"; then
+if test -f "$log_file"; then :; else
   if test -z "$ChangeLog"; then
     for f in ${1+"$@"}; do
       case "$f" in
-      ChangeLog* | */ChangeLog*)
-        if test -z "$ChangeLog"; then
+        ChangeLog* | */ChangeLog*)
+          if test -z "$ChangeLog"; then
            ChangeLog="$f"
-       else
-           echo "$name: multiple ChangeLog files: $ChangeLog and $f" >&2
-           break
-       fi
+         else
+           func_fatal_error "multiple ChangeLog files: $ChangeLog and $f"
+         fi
        ;;
       esac
     done
   fi
 
-  echo "$name: checking commit message..." >&2
-  if $first; then
+  func_error "$progname: checking commit message..."
+  if $opt_first; then
     skipping=:
     sed 's,^,+,' < ${ChangeLog-ChangeLog} |
-    while read line; do
-      case "$line" in
-      "+") if $skipping; then skipping=false; else break; fi;;
-      "+ "*) 
-       echo "$name: *** Warning: lines should start with tabs, not spaces; 
ignoring line:" >&2
-       echo "$line" | sed 's/^.//' >&2;;
-      "+       "*)
-        $skipping || echo "$line" ;;
-      esac
-    done |
-    sed 's,^\+ ,,' > "$log_file" || break
+      while read line; do
+        case "$line" in
+          "+") if $skipping; then skipping=false; else break; fi;;
+          "+ "*)
+           func_error "*** Warning: lines should start with tabs, not spaces; 
ignoring line:"
+           echo "$line" | sed 's/^.//' >&2;;
+          "+   "*)
+            $skipping || echo "$line" ;;
+        esac
+      done |
+        sed 's,^\+     ,,' > "$log_file" || exit $EXIT_FAILURE
   else
-    $CVS $cvsopt diff -u ${ChangeLog-ChangeLog} |
-    while read line; do
-      case $line in
-      "--- "*) :;;
-      "-"*)
-       echo "$name: *** Warning: the following line in ChangeLog diff is 
suspicious:" >&2
-       echo "$line" | sed 's/^.//' >&2;;
-      "+ "*)
-       echo "$name: *** Warning: lines should start with tabs, not spaces; 
ignoring line:" >&2
-       echo "$line" | sed 's/^.//' >&2;;
-      "+") echo;;
-      "+       "*) echo "$line";;
-      esac
-    done |
-    sed -e 's,\+       ,,' -e '/./p' -e '/./d' -e '1d' -e '$d' > "$log_file" \
-    || break
+    $CVS $cvs_flags diff -u ${ChangeLog-ChangeLog} |
+      while read line; do
+        case $line in
+          "--- "*) :;;
+          "-"*)
+           func_error "*** Warning: the following line in ChangeLog diff is 
suspicious:"
+           echo "$line" | sed 's/^.//' >&2;;
+          "+ "*)
+           func_error "*** Warning: lines should start with tabs, not spaces; 
ignoring line:"
+           echo "$line" | sed 's/^.//' >&2;;
+          "+") echo ;;
+          "+   "*) echo "$line";;
+        esac
+      done |
+        sed -e 's,\+   ,,' -e '/./p' -e '/./d' -e '1d' -e '$d' > "$log_file" \
+    || exit $EXIT_FAILURE
   fi
-# The sed script above removes "+TAB" from the beginning of a line, then
-# deletes the first and/or the last line, when they happen to be empty
+  # The sed script above removes "+TAB" from the beginning of a line, then
+  # deletes the first and/or the last line, when they happen to be empty
 fi
 
-if grep '[^    ]' < "$log_file" > /dev/null; then :; else
-  echo "$name: empty commit message, aborting" >&2
-  break
-fi
+grep '[^       ]' < "$log_file" > /dev/null ||
+  func_fatal_error "empty commit message, aborting"
 
 if grep '^$' < "$log_file" > /dev/null; then
-  echo "$name: *** Warning: blank lines should not appear within commit 
messages." >&2
-  echo "$name: *** They should be used to separate distinct commits." >&2
+  func_error "*** Warning: blank lines should not appear within commit 
messages."
+  func_error "*** They should be used to separate distinct commits."
 fi
 
-${PAGER-more} "$log_file" || break
+${PAGER-more} "$log_file" || exit $EXIT_FAILURE
 
 sleep 1 # give the user some time for a ^C
 
+filelist=`cvs -nq up 2>/dev/null | grep '^[MAD] ' | sed 's/^. //'`
+
 # Do not check for empty $log_file again, even though the user might have
 # zeroed it out.  If s/he did, it was probably intentional.
 
-if $commit; then
-  $CVS $cvsopt commit $commitopt -F $log_file ${1+"$@"} || break
+if $opt_commit; then
+  $CVS $cvs_flags commit $commit_flags -F $log_file ${1+"$@"} || exit 
$EXIT_FAILURE
+fi
+
+# Send a copy of the log_file if sendmail_to was set:
+if test -n "$sendmail_to"; then
+  notify_file="${log_file}.2"
+  func_error "Mailing commit notification to $sendmail_to"
+  test $# -gt 0 && filelist="$@"
+
+  {
+    test -f CVS/Root &&
+        echo "CVSROOT: `sed -e 's,.*:,,g' CVS/Root`"
+    test -f $MKSTAMP &&
+        echo "TIMESTAMP:       `$SHELL $MKSTAMP < ./ChangeLog`"
+    test -f CVS/Repository &&
+        echo "Module name:     `cat CVS/Repository`"
+    test -f CVS/Tag &&
+        echo "Branch:          `sed -e 's,^T,,;1q' CVS/Tag`"
+    test -f CVS/Root &&
+        echo "Changes by:      `sed -e 's,:.*$,,g;s,^.*:,,' CVS/Root`"
+    echo ""
+    echo "Log Message:"
+    sed -e 's,^,       ,' "$log_file"
+    test -f "$signature_file" && cat "$signature_file"
+  } > "$notify_file"
+
+  if test -n "$sendmail_from"; then
+    $SHELL $MAILNOTIFY -F "$sendmail_from" -s "`echo $filelist`" -f 
"$notify_file" -m "text/plain" "$sendmail_to"
+  else
+    $SHELL $MAILNOTIFY -s "`echo $filelist`" -f "$notify_file" -m "text/plain" 
"$sendmail_to"
+  fi
 fi
 
-main_repeat=false
-done
+$RM "${log_file}*"
 
-rm -f "$log_file"
+exit $EXIT_SUCCESS
 
-# if main_repeat was not set to `false', we failed
-$main_repeat && exit 1
-exit 0
+# Local Variables:
+# mode:shell-script
+# sh-indentation:2
+# End:
Index: config/mailnotify
===================================================================
RCS file: config/mailnotify
diff -N config/mailnotify
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ config/mailnotify 29 Feb 2004 16:51:49 -0000
@@ -0,0 +1,441 @@
+#!/bin/sh
+#
+# mailnotify (GNU cvs-utils) version 0.2
+# Written by Gary V. Vaughan <address@hidden>
+
+# Copyright (C) 2004 Free Software Foundation, Inc.
+# This is free software; see the source for copying conditions.  There is NO
+# warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, a copy can be downloaded from
+# http://www.gnu.org/copyleft/gpl.html, or by writing to the Free
+# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
+# MA 02111-1307, USA.
+
+# Usage: $progname [OPTION]... [--] to-address...
+#
+# -C ADDR   --carbon-copy=ADDR  send a carbon-copy to ADDR
+# -F ADDR   --from=ADDR         override default from address with ADDR
+# -f FILE   --filename=FILE     content of this part
+# -m TYPE   --mime-type=TYPE    mime-type of this part
+# -n                            another mime part (-f, -m) to follow
+# -o FILE   --output-file=FILE  output to FILE instead of sending
+# -s TEXT   --subject=TEXT      set subject header
+# -v        --verbose           run in verbose mode
+#           --version           print version information
+# -h,-?     --help              print short or long help message
+
+# Assemble a (possibly multi-part) mime message and hand it to the local
+# sendmail for onward delivery.  MUAs tend to mangle patch attachments in
+# various ways: not setting the mime-type correctly, line wrapping the
+# patch itself, escaping certain values, etc.  This script is designed to
+# make it easier to send a patch as a MIME attachment, though it is general
+# enough that it might be useful otherwise.
+
+# For example to send a patch as an attachment, assuming the patch itself
+# is in PATCHFILE:
+#
+#    echo 'Applied to HEAD' > body
+#    $progname -f body -m text/plain -n -f PATCHFILE -m text/x-patch \
+#        -s 'FYI: PATCHFILE' address@hidden
+
+# You will probably find using this script in conjunction with clcommit
+# or cvsapply will save you an awful lot of typing.
+
+# Report bugs to <address@hidden>
+
+: ${TMPDIR=/tmp}
+: ${HOST=`hostname`}
+: ${MV="mv -f"}
+: ${RM="rm -f"}
+: ${SED="sed"}
+
+dirname="s,/[^/]*$,,"
+basename="s,^.*/,,g"
+
+# Work around backward compatibility issue on IRIX 6.5. On IRIX 6.4+, sh
+# is ksh but when the shell is invoked as "sh" and the current value of
+# the _XPG environment variable is not equal to 1 (one), the special
+# positional parameter $0, within a function call, is the name of the
+# function.
+progpath="$0"
+
+# The name of this program:
+progname=`echo "$progpath" | $SED "$basename"`
+PROGRAM=mailnotify
+
+# Global variables:
+EXIT_SUCCESS=0
+EXIT_FAILURE=1
+
+multipart=1
+outputfile=""
+
+exit_cmd=:
+
+sed_mail_address='s,^.*<\(.*\)>.*$,\1,'
+
+# func_echo arg...
+# Echo program name prefixed message.
+func_echo ()
+{
+    echo $progname: ${1+"$@"}
+}
+
+# func_error arg...
+# Echo program name prefixed message to standard error.
+func_error ()
+{
+    echo $progname: ${1+"$@"} 1>&2
+}
+
+# func_fatal_error arg...
+# Echo program name prefixed message to standard error, and exit.
+func_fatal_error ()
+{
+    func_error ${1+"$@"}
+    exit $EXIT_FAILURE
+}
+
+# func_verbose arg...
+# Echo program name prefixed message in verbose mode only.
+func_verbose ()
+{
+    $opt_verbose && func_error ${1+"$@"}
+}
+
+# func_fatal_help arg...
+# Echo program name prefixed message to standard error, followed by
+# a help hint, and exit.
+func_fatal_help ()
+{
+    func_error ${1+"$@"}
+    func_fatal_error "Try \`$progname --help' for more information."
+}
+
+# func_missing_arg argname
+# Echo program name prefixed message to standard error and set global
+# exit_cmd.
+func_missing_arg ()
+{
+    func_error "missing argument for $1"
+    exit_cmd=exit
+}
+
+# Echo short help message to standard output and exit.
+func_usage ()
+{
+    $SED '/^# Usage:/,/# -h/ {
+        s/^# //; s/^# *$//;
+       s/\$progname/'$progname'/;
+       p;
+    }; d' < "$progpath"
+    echo
+    echo "run \`$progname --help | more' for full usage"
+    exit $EXIT_SUCCESS
+}
+
+# func_help
+# Echo long help message to standard output and exit.
+func_help ()
+{
+    $SED '/^# Usage:/,/# Report bugs to/ {
+        s/^# //; s/^# *$//;
+       s/\$progname/'$progname'/;
+       p;
+     }; d' < "$progpath"
+    exit $EXIT_SUCCESS
+}
+
+# func_version
+# Echo version message to standard output and exit.
+func_version ()
+{
+    $SED '/^# '$PROGRAM' (GNU /,/# warranty; / {
+        s/^# //; s/^# *$//;
+        s/\((C)\)[ 0-9,-]*\( [1-9][0-9]*\)/\1\2/;
+        p;
+     }; d' < "$progpath"
+     exit $EXIT_SUCCESS
+}
+
+# Parse options once, thoroughly.  This comes as soon as possible in
+# the script to make things like `mailnotify --version' happen quickly.
+{
+  # sed scripts:
+  my_sed_single_opt='1s/^\(..\).*$/\1/;q'
+  my_sed_single_rest='1s/^..\(.*\)$/\1/;q'
+  my_sed_long_opt='1s/^\(--[^=]*\)=.*/\1/;q'
+  my_sed_long_arg='1s/^--[^=]*=//'
+
+  while test $# -gt 0; do
+    opt="$1"
+    shift
+    case $opt in
+      -C|--carbon-copy) test $# -eq 0 && func_missing_arg "$opt" && break
+                       cc="$1"
+                       shift
+                       ;;
+
+      -F|--from)       test $# -eq 0 && func_missing_arg "$opt" && break
+                       from="$1"
+                       shift
+                       ;;
+
+      -f|--filename)   test $# -eq 0 && func_missing_arg "$opt" && break
+                       if test -f "$1"; then :; else
+                         func_error "\`$1' does not exist"
+                         exit_cmd=exit
+                         break
+                       fi
+                       eval datafile$multipart=\"$1\"
+                       shift
+                       ;;
+
+      -m|--mime-type)  test $# -eq 0 && func_missing_arg "$opt" && break
+                       case $1 in
+                         text/*) ;;
+                         */*) func_error "only text/* mime-types supported"
+                              ;;
+                         *)   func_error "invalid mime-type, \`$1'"
+                              exit_cmd=exit
+                              ;;
+                       esac
+                       eval ctype$multipart=\"$1\"
+                       shift
+                       ;;
+
+      -n)              if eval test -z \"\$ctype$multipart\" ||
+                          eval test -z \"\$datafile$multipart\"; then
+                         func_fatal_error "One part is incomplete -- each part 
needs a filename and a mime-type"
+                       fi
+                       multipart=`expr 1 + $multipart`
+                       ;;
+
+      -o|--output-file)        test $# -eq 0 && func_missing_arg "$opt" && 
break
+                       outputfile="$1"
+                       shift
+                       ;;
+
+      -s|--subject)    test $# -eq 0 && func_missing_arg "$opt" && break
+                       subject="$1"
+                       shift
+                       ;;
+
+      -v|--verbose)    opt_verbose=:                   ;;
+
+      # Separate optargs to long options:
+      
--carbon-copy=*|--from=*|--filename=*|--mime-type=*|--output-file=*|--subject=*)
+                       arg=`echo "$opt" | $SED "$my_sed_long_arg"`
+                       opt=`echo "$opt" | $SED "$my_sed_long_opt"`
+                       set -- "$opt" "$arg" ${1+"$@"}
+                       ;;
+
+      # Separate optargs to short options:
+      -C*|-F*|-f*|-m*|-o*|-s*)
+                       arg=`echo "$opt" |$SED "$my_sed_single_rest"`
+                       opt=`echo "$opt" |$SED "$my_sed_single_opt"`
+                       set -- "$opt" "$arg" ${1+"$@"}
+                       ;;
+
+      # Separate non-argument short options:
+      -n*|-v*)
+                       rest=`echo "$opt" |$SED "$my_sed_single_rest"`
+                       opt=`echo "$opt" |$SED "$my_sed_single_opt"`
+                       set -- "$opt" "-$rest" ${1+"$@"}
+                       ;;
+
+      -\?|-h)          func_usage                                      ;;
+      --help)          func_help                                       ;;
+      --version)       func_version                                    ;;
+      --)              break                                           ;;
+      -*)              func_fatal_help "unrecognized option \`$opt'"   ;;
+      *)               set -- "$opt" ${1+"$@"};      break             ;;
+    esac
+  done
+
+  test $# -gt 0 ||
+    func_fatal_help "no destination address"
+
+  if test -z "$outputfile"; then
+    if test -z "$subject" ||
+       eval test -z \"\$ctype$multipart\" ||
+       eval test -z \"\$datafile$multipart\"; then
+      func_fatal_error "if output is not directed to a file -s, -f, and -m are 
all required"
+    fi
+  else
+    eval test -n \"\$datafile$multipart\" ||
+        func_fatal_error "-f is required."
+    eval test -n \"\$ctype$multipart\" ||
+        func_fatal_error "with output directed to a file, -m is required"
+  fi
+  eval test -f \"\$datafile$multipart\" ||
+    eval func_fatal_error \"\$datafile$multipart: file not found\"
+}
+
+
+# func_headers outfile destination
+# Generate common headers to OUTFILE, where DESTINATION is a comma
+# separated list of fully qualified destination addresses.
+func_headers ()
+{
+    my_outfile="$1"
+    my_destination="$2"
+    my_sed_version_no='/^# '$PROGRAM' (GNU / { s/^# .*version //; p; }; d'
+
+    {
+       echo "User-Agent: $PROGRAM/`$SED \"$my_sed_version_no\" < $progpath`"
+       echo "MIME-Version: 1.0"
+       test -n "$from" && echo "From: $from"
+       echo "To: $my_destination"
+       test -n "$cc" && echo "CC: $cc"
+       test -n "$subject" && echo "Subject: $subject"
+    } > "$my_outfile"
+}
+
+
+# func_single_content outfile
+# Send the only message part as a single mime mail part.
+func_single_content ()
+{
+    my_outfile="$1"
+
+    cat >> "$my_outfile" <<EOF
+Content-Type: $ctype1
+Content-Transfer-Encoding: 7bit
+
+`cat $datafile1`
+EOF
+}
+
+
+# func_multipart_content outfile
+# Send the various message parts to OUTFILE as a multipart mime mail.
+func_multipart_content ()
+{
+    my_outfile="$1"
+    boundary="Boundary-${HOST}-$$-`date | tr ' :' -`"
+    cat <<EOF >> "$my_outfile"
+Content-Type: Multipart/Mixed;
+       boundary="$boundary"
+
+This is a multimedia message in MIME format.  If you are reading
+this prefix, your mail reader does not understand MIME.  You may
+wish to look into upgrading to a mime-aware mail reader.
+EOF
+    i=0
+    while test $i -lt $multipart
+    do
+      i=`expr 1 + $i`
+      {
+       echo ""
+       echo "--$boundary"
+       eval echo \"Content-Type: \$ctype$i\"
+       echo "Content-Transfer-Encoding: 7bit"
+       echo ""
+       eval cat \"\$datafile$i\"
+      } >> "$my_outfile"
+    done
+    {
+      echo ""
+      echo "--${boundary}--"
+      echo ""
+    } >> "$my_outfile"
+}
+
+
+# func_sendmail infile destination [from]
+# Send the message in INFILE to the space delimited list of destination
+# addresses in DESTINATION.  If FROM is given, it is the address the
+# mail purports to be from.
+# BEWARE: Many MTAs will refuse mail where FROM does not match the actual
+#         sending domain.
+func_sendmail ()
+{
+    my_infile="$1"
+    my_destination="$2"
+    my_from="$3"
+
+    from_name=`echo "$my_from" | sed 's, *<.*> *$,,;s,",,g'`
+    from_addr=`echo "$my_from" | sed "$sed_mail_address"`
+
+    SENDMAIL=sendmail
+    for try_sendmail in sendmail /usr/lib/sendmail /usr/sbin/sendmail; do
+       if which $try_sendmail >/dev/null; then
+           SENDMAIL=$try_sendmail
+           break
+       fi
+    done
+
+    func_verbose "Delivering mail, please wait..."
+    if test -n "$from_name"; then
+        $SENDMAIL -F "$from_name" -f "$from_addr" $my_destination < 
"$my_infile"
+    elif test -n "$from_addr"; then
+        $SENDMAIL -f "$from_addr" $my_destination < "$my_infile"
+    else
+        $SENDMAIL $my_destination < "$my_infile"
+    fi
+    if test $? -eq 0; then
+        func_verbose "...succeeded."
+        rm $my_infile
+    else
+        func_fatal_error "Mail delivery failed, draft mail is in $my_infile"
+    fi
+}
+
+
+
+## ----- ##
+## main. ##
+## ----- ##
+
+{
+  fname="${TMPDIR}/$PROGRAM$RANDOM-$RANDOM.$$"
+  trap 'rm -f "$fname"; exit 1' 1 2 15
+
+  destination=""
+  for to;
+  do
+      case $destination in
+         "") destination="$to" ;;
+          *)  destination="$destination, $to" ;;
+      esac
+  done
+
+  func_headers "$fname" "$destination"
+  if test $multipart -gt 1; then
+      func_multipart_content "$fname"
+  else
+      func_single_content "$fname"
+  fi
+
+  if test -z "$outputfile"; then
+      destination=""
+      for to; do
+          to_addr=`echo "$to" | sed "$sed_mail_address"`
+         test -n "$to_addr" || to_addr="$to"
+         destination="$destination $to_addr"
+      done
+      func_sendmail "$fname" "$destination" "$from"
+  else
+      mv $fname $outputfile || exit $EXIT_FAILURE
+  fi
+}
+
+exit $EXIT_SUCCESS
+
+# Local Variables:
+# mode:shell-script
+# sh-indentation:2
+# End:

reply via email to

[Prev in Thread] Current Thread [Next in Thread]